class ColorPickerBox
{
	int x;
	int y;
	int segs;
	int steps;
	int boxWidth;
	int boxHeight;
	int cellHeight;
	int cellWidth;
	int borderWidth = 1;
	color currentColor, oldColor;
	boolean wipeButton = false;
	int brushSize = 1;
       AudioSample rattle;
	int clearButtonStart;
	int brushBoxStart;
	int currentColorBoxHeight = 50;
	PFont fontA;
  
	ColorPickerBox( AudioSample sample, int tx, int ty, int tboxWidth, int tboxHeight, int tsegs, int tsteps )
	{
                rattle = sample;
		x = tx;
		y = ty;
		segs = tsegs;
		steps = tsteps;
		boxWidth = tboxWidth;
		boxHeight = tboxHeight;
		cellWidth = boxWidth / steps;
		cellHeight = boxHeight / ( segs + 1 );
		brushBoxStart =  y + borderWidth + boxHeight + currentColorBoxHeight + 25;
		clearButtonStart =  brushBoxStart + currentColorBoxHeight + 25;
                currentColor = color( 255 );
		fontA = loadFont("Ziggurat-HTF-Black-32.vlw");
		textFont(fontA, 30);
	}

void update( int X, int Y )
{
	if( X > x + borderWidth && X < boxWidth + x - borderWidth
	&& Y > y + borderWidth && Y < boxHeight + y - borderWidth )
	{
		currentColor = get( X, Y );
                 if( currentColor != oldColor )
                 {
                   oldColor = currentColor;
                   //println( "new color" );
                   rattle.trigger();
                 }
		drawColorBox();
	}

	if( X > x + borderWidth && X < boxWidth + x - borderWidth
	&&  Y > y + clearButtonStart && Y < clearButtonStart + currentColorBoxHeight )
	{
		wipeButton = true;
	}
	else
	{
		wipeButton = false;
	}

	if( X > x + borderWidth && X < boxWidth + x - 10
	&& Y > y + brushBoxStart && Y < y + brushBoxStart + currentColorBoxHeight )
	{
		brushSize =  X - x + 5; 
	}
}

color getCurrentColor()
{

  	return currentColor;
}
color getBrushSize()
{
	return brushSize;
}

boolean getWipeButton()
{
        if( wipeButton )
        {
          wipeButton = false;
          return true;
        }
  	return false;
}

void drawBrushBox()
{
	fill( 0 );
	pushMatrix();
	translate( x + borderWidth, brushBoxStart );
	rect( 0, 0, boxWidth, currentColorBoxHeight );
	strokeWeight( 3 );
	stroke( 255 );
	fill( 255 );
	line( 0, currentColorBoxHeight / 2 , boxWidth, currentColorBoxHeight / 2 );
	rectMode( CENTER );
	rect( brushSize, currentColorBoxHeight / 2, 5, brushSize / 4 );
	rectMode( CORNER );
	popMatrix();
}

void drawColorBox()
{
	stroke( 255 );
	strokeWeight( 0 );
	fill( currentColor );  
	rect(  x + borderWidth, y + borderWidth + boxHeight + 10, boxWidth , currentColorBoxHeight - borderWidth );
  
}
 void display()
 {
	//draw where the current color is
	drawColorBox();
//	drawBrushBox();

	fill( 0 );
	stroke( 0 );
	//main box
	rect( x, y, boxWidth + borderWidth * 2, boxHeight + borderWidth * 2 );
  
	//draw the color picker
	pushMatrix();
	translate ( x + borderWidth, y + borderWidth );
	for (int j = 0; j < steps; j++)
	{
		color[] cols = { 
		color(255-(255/steps)*j, 255-(255/steps)*j, 0), 
		color(255-(255/steps)*j, (255/1.5)-((255/1.5)/steps)*j, 0), 
		color(255-(255/steps)*j, (255/2)-((255/2)/steps)*j, 0), 
		color(255-(255/steps)*j, (255/2.5)-((255/2.5)/steps)*j, 0), 
		color(255-(255/steps)*j, 0, 0), 
		color(255-(255/steps)*j, 0, (255/2)-((255/2)/steps)*j), 
		color(255-(255/steps)*j, 0, 255-(255/steps)*j), 
		color((255/2)-((255/2)/steps)*j, 0, 255-(255/steps)*j), 
		color(0, 0, 255-(255/steps)*j),
		color(0, 255-(255/steps)*j, (255/2.5)-((255/2.5)/steps)*j), 
		color(0, 255-(255/steps)*j, 0), 
		color((255/2)-((255/2)/steps)*j, 255-(255/steps)*j, 0) };

		for (int i = 0; i <segs; i++)
		{
			fill(cols[i]); 
			rect(cellWidth *j , cellHeight * i, cellWidth , cellHeight );
		}
	} 
	//draw the black and white boxes
	fill( 0 );
	rect( 0, cellHeight * segs + 1, cellWidth *2  , cellHeight);
	fill( 255 );
	rect( cellWidth * 2 , cellHeight * segs + 1, cellWidth *2  , cellHeight);

	popMatrix();

	//wipe button
	strokeWeight( 3 );
	stroke( 255 );
	fill( 0 );
	rect(  x + borderWidth, clearButtonStart, boxWidth , currentColorBoxHeight - borderWidth );
	fill( 255 );
	text( "wipe", x + 10, clearButtonStart + currentColorBoxHeight / 2 + 10 );

	}
}
