/*
    Drips drips = new Drips();
    
    drips.addMouseHistory( mouseX, mouseY);
    drips.addDrip( mouseX, mouseY, brushSize);

    drips.drawDrips();
*/



class Drips
{
  ArrayList drips;
  int mouseHistory = 20;
  int dripSize = 7;
  int minBrushSize;
  int maxBrushSize;

  PVector [] oldMouse = new PVector[ mouseHistory ];
  Drips( int tminBrushSize, int tmaxBrushSize)
  {
    minBrushSize = tminBrushSize;
    maxBrushSize = tmaxBrushSize;

    newMouseHistory();
    drips = new ArrayList(); 
  } 
void newMouseHistory()
{
    for( int i = 0; i < mouseHistory; i ++ )
    {
      oldMouse[i] = new PVector( 0, 0 );
    }
}
  void addDrip(int X, int Y, int brushSize, color dripColor )
  {
    int totalX = 0;
    int totalY = 0;
    int historyCheck = (int)map( brushSize, minBrushSize, maxBrushSize, 3, mouseHistory );    
    if( historyCheck > mouseHistory ) historyCheck = mouseHistory;
 //   println( historyCheck );
    for( int i = 0; i < historyCheck ; i ++ )
    {
      totalX += oldMouse[i].x ;
      totalY += oldMouse[i].y ;
    }
    totalX /= historyCheck;
    totalY /= historyCheck;
    //compare the current with the mode
    float dripScore =  abs(totalX - X ) + abs(totalY - Y );
    // println( dripScore );
    if( dripScore < 3 )
    {
      int dripLength = (int)( (3 - dripScore ) * 20 );
      drips.add( new Drip( X, Y, dripLength, dripColor ) ) ;
      //stop too many drips
      newMouseHistory();
    }

  }


  void drawDrips()
  {
    //draw the drips
    for( int i = drips.size() - 1; i >= 0; i -- )
    {
      Drip drip = (Drip) drips.get(i);
      drip.drawDrip();
      if( drip.finished() )
      {
        drips.remove(i);
      }
    }
  }
  void addMouseHistory(int X, int Y)
  {

    for( int i = mouseHistory - 1; i >= 1 ; i -- )
    {
      oldMouse[ i ].x = oldMouse[ i - 1].x;
      oldMouse[ i ].y = oldMouse[ i - 1].y;    
    }
    oldMouse[0].x = X;
    oldMouse[0].y = Y;
  }

}

class Drip
{
  int X;
  int Y;
  int dripLength;
  int brushSize;
  int progress;
  color dripColor;
  Drip( int tX, int tY, int tlength, color tdripColor )
  {
    X = tX;
    Y = tY;
    dripLength = tlength;
    brushSize = 7;
    progress = 0;
    dripColor = tdripColor;
  }

  //draw the drip
  void drawDrip()
  {
    noStroke();
    fill( dripColor );
    ellipse( X, Y + progress ++, brushSize, brushSize );   
  }
  boolean finished()
  {
    if( progress > dripLength ) return true;
    return false;
  }  
}

